﻿<#
Script: DeviceClient.ps1
Software Title: Gigaframe.Com.PowerShell.CGI
Copyright (C) 2022 Gigaframe.com, Robert Demelo
All rights reserved.
Read License terms, conditions and disclaimer
LICENSE.txt
WARRANTY_LIABILITY_DISCLAIMER.txt
THIRD_PARTY_LICENSE_README.txt

WARRANTY AND LIABILITY DISCLAIMER

THIS SOFTWARE AND ANY SUPPLIED AND GENERATED CODE IS 
PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR, 
CONTRIBUTORS OR ANY ASSOCIATED PARTIES BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE. 

#>

Clear-Host;

$DEVICEID = $env:COMPUTERNAME;
$USERID = $env:USERNAME;
$ARCHTECTURE = $env:PROCESSOR_ARCHITECTURE;
$OS =  (Get-WmiObject win32_operatingsystem).Version;
$TAG = (Get-WmiObject win32_bios).SerialNumber; # or from imaging file
$SERIAL = (Get-WmiObject win32_bios).SerialNumber;
$INFO = [SYSTEM.DATETIME]::Now.ToString("yyy-MM-dd-hh-mm-ss");
$drvs = (Get-PSDrive);
$DRIVES = "";
Foreach($d in $drvs)
{
    If($d.Provider.Name -eq "FileSystem")
    {
        $DRIVES += "$($d.Name)|$($d.Used)|$($d.Free)|$($d.Root);";
    }
}
$MAPPEDDRIVES = "";
$mapdrvs = (Get-WmiObject -ClassName Win32_MappedLogicalDisk | Select PSComputerName, Name,ProviderName);
Foreach($d in $mapdrvs)
{
    $MAPPEDDRIVES += "$($d.Name)|$($d.ProviderName);";
}

[System.Net.WebClient] $wc = [System.Net.WebClient]::new();
[System.Collections.Specialized.NameValueCollection] $data = [System.Collections.Specialized.NameValueCollection]::new();
[string] $url = "http://localhost/psroot/webservice.ps1?m=SAVEDEVICE";

$data["DEVICEID"] = $DEVICEID;
$data["USERID"] = $USERID;
$data["ARCHTECTURE"] = $ARCHTECTURE;
$data["OS"] = $OS;
$data["TAG"] = $TAG;
$data["SERIAL"] = $SERIAL;
$data["INFO"] = $INFO;
$data["DRIVES"] = $DRIVES;
$data["MAPPEDDRIVES"] = $MAPPEDDRIVES;

[byte[]] $response = $wc.UploadValues($url, "POST", $data);
[string] $resposeString = $wc.Encoding.GetString($response);
Write-Host($resposeString);