CREATE DATABASE ORG;
GO

USE ORG;

CREATE TABLE USERS
(
	USERID varchar(50) NOT NULL,
	FIRSTNAME varchar(50) DEFAULT NULL,
	LASTNAME varchar(50) DEFAULT NULL,
	PHONE varchar(20) DEFAULT NULL,
	EMAIL varchar(50) DEFAULT NULL,
	PWD varchar(250) DEFAULT NULL,
	PRIMARY KEY (USERID)
);

CREATE TABLE GROUPS 
(
	GROUPID varchar(50) NOT NULL,
	GROUPNAME varchar(50) DEFAULT NULL,
	PRIMARY KEY (GROUPID)
);

CREATE TABLE USERGROUPS
(
	USERID varchar(50) NOT NULL,
	GROUPID varchar(50) NOT NULL,
	PRIMARY KEY (USERID, GROUPID)
);

CREATE TABLE LOCATIONS 
(
	LOCATIONID varchar(50) NOT NULL,
	LOCATIONNAME varchar(50) DEFAULT NULL,
	DESCRIPTOR varchar(50) DEFAULT NULL,
	PRIMARY KEY (LOCATIONID)
);

CREATE TABLE DEVICES
(
	DEVICEID varchar(50) NOT NULL,
	USERID varchar(50) DEFAULT NULL,
	ARCHTECTURE varchar(50) DEFAULT NULL,
	OS varchar(50) DEFAULT NULL,
	TAG varchar(50) DEFAULT NULL,
	SERIAL varchar(50) DEFAULT NULL,
	INFO varchar(512) DEFAULT NULL,
	DRIVES varchar(512) DEFAULT NULL,
	MAPPEDDRIVES varchar(512) DEFAULT NULL,
	LASTUPDATE datetime NOT NULL,
	PRIMARY KEY (DEVICEID)
);

CREATE TABLE DEVICEPRODUCTS
(
	DEVICEPRODUCTID varchar(50) NOT NULL,
	DEVICEID varchar(50) NOT NULL,
	PRODUCTNAME varchar(100) NOT NULL,
	PRODUCTVERSION varchar(100) NOT NULL,
	PRODUCTDATA varchar(100) NULL,
	LASTUPDATE datetime NOT NULL,
	PRIMARY KEY (DEVICEPRODUCTID,DEVICEID,PRODUCTVERSION)
);

GO

/*
SELECT EncryptByPassPhrase('MYKEY', 'PASSWORD' )
SELECT CONVERT(VARCHAR(50), DecryptByPassPhrase('MYKEY', EncryptByPassPhrase('MYKEY', 'PASSWORD' )))
*/

DELETE FROM [USERS] ; 

INSERT INTO [USERS] ([USERID],[FIRSTNAME],[LASTNAME],[PHONE],[EMAIL],[PWD]) VALUES 
('JMARKOV','Jake','Markov','555-555-5555','JMARKOV@GIGAFRAME.COM',EncryptByPassPhrase('MYKEY', 'PASSWORD' ));
INSERT INTO [USERS] ([USERID],[FIRSTNAME],[LASTNAME],[PHONE],[EMAIL],[PWD]) VALUES 
('RDEMELOP','Robert','Demelo','555-555-5555','RDEMELOP@GIGAFRAME.COM',EncryptByPassPhrase('MYKEY', 'PASSWORD' ));
INSERT INTO [USERS] ([USERID],[FIRSTNAME],[LASTNAME],[PHONE],[EMAIL],[PWD]) VALUES 
('RFRANKLIN','Randy','Franklin','555-555-5555','RFRANKLIN@GIGAFRAME.COM',EncryptByPassPhrase('MYKEY', 'PASSWORD' ));
INSERT INTO [USERS] ([USERID],[FIRSTNAME],[LASTNAME],[PHONE],[EMAIL],[PWD]) VALUES 
('RMERCURY','Rachel','Mercury','555-555-5555','RMERCURY@GIGAFRAME.COM',EncryptByPassPhrase('MYKEY', 'PASSWORD' ));

DELETE FROM [GROUPS] ; 

INSERT INTO [GROUPS] ([GROUPID],[GROUPNAME]) VALUES ('USER','Users');
INSERT INTO [GROUPS] ([GROUPID],[GROUPNAME]) VALUES ('ADMIN','Administrators');

GO

