﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Collections.Specialized;
using System.Threading;

/*
 Testing Output
 SELECT [DEVICEPRODUCTID]
      ,[DEVICEID]
      ,[PRODUCTNAME]
      ,[PRODUCTVERSION]
      ,[PRODUCTDATA]
      ,[LASTUPDATE]
  FROM [ORG].[dbo].[DEVICEPRODUCTS]
  ORDER BY PRODUCTDATA, DEVICEID, LASTUPDATE DESC
 */

namespace WebLoadTester
{
    class Program
    {
        static void Main(string[] args)
        {
            //DoRequest();
            //return;

            List<Thread> threads = new List<Thread>();

            for (int i = 0; i < 20; i++)
            {
                // Create a secondary thread by passing a ThreadStart delegate  
                Thread t = new Thread(new ThreadStart(DoRequest));
                t.Name = "Thread " + i.ToString();
                // Start secondary thread  
                t.Start();

                threads.Add(t);

                Console.WriteLine(t.Name);
            }

            bool allThreadsComplete = false;
            
            while (!allThreadsComplete) 
            {
                allThreadsComplete = true;
                foreach (Thread t in threads)
                {
                    if (t.IsAlive) 
                    {
                        Console.WriteLine(t.Name + " alive");
                        allThreadsComplete = false;
                    }
                }
                Thread.Sleep(200);
            }
            
     
            //Pause
            //Console.ReadKey();

        }

        public static void DoRequest()
        {

            /*
             [DEVICEPRODUCTID]
              ,[DEVICEID]
              ,[PRODUCTNAME]
              ,[PRODUCTVERSION]
              ,[PRODUCTDATA]
              ,[LASTUPDATE]
             */

            string deviceid = Guid.NewGuid().ToString();

            for (int i = 0; i < 100; i++)
            {
                string deviceproductid = Guid.NewGuid().ToString();
                string productversion = deviceproductid;

                var wb = new WebClient();
                var data = new NameValueCollection();
                string url = "http://localhost/psroot/webservice.ps1?m=SAVEDEVICEPRODUCT&tn=" + Thread.CurrentThread.Name;
                data["DEVICEPRODUCTID"] = deviceproductid;
                data["DEVICEID"] = deviceid;
                data["PRODUCTVERSION"] = productversion;
                var response = wb.UploadValues(url, "POST", data);
                string resposeString = wb.Encoding.GetString(response);
                Console.WriteLine(resposeString);
            }

            //Method 2
            /*
            string url1 = "http://localhost/psroot/index.ps1";
            var request = (HttpWebRequest)WebRequest.Create(url1);

            var postData = "param1=" + Uri.EscapeDataString("value1");
            postData += "&param2=" + Uri.EscapeDataString("value2");
            var data1 = Encoding.ASCII.GetBytes(postData);

            request.Method = "POST";
            request.ContentType = "application/x-www-form-urlencoded";
            request.ContentLength = data1.Length;

            using (var stream = request.GetRequestStream())
            {
                stream.Write(data1, 0, data1.Length);
            }

            var response1 = (HttpWebResponse)request.GetResponse();
            */
        }
    }
}
