#!D:\dev\psroot\Gigaframe.Com.Powershell.CGI\Gigaframe.Com.PowerShell.CGI.exe

<#
Script: WebService.ps1
Software Title: Gigaframe.Com.PowerShell.CGI
Copyright (C) 2022 Gigaframe.com, Robert Demelo
All rights reserved.
Read License terms, conditions and disclaimer
LICENSE.txt
WARRANTY_LIABILITY_DISCLAIMER.txt
THIRD_PARTY_LICENSE_README.txt

WARRANTY AND LIABILITY DISCLAIMER

THIS SOFTWARE AND ANY SUPPLIED AND GENERATED CODE IS 
PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR, 
CONTRIBUTORS OR ANY ASSOCIATED PARTIES BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE. 

#>

Using Namespace System.Collections.Generic;

<# INLINE INCLUDES #>
(. $PSScriptRoot\Gigaframe.Com.PowerShell.CGI.Common.ps1);
(. $PSScriptRoot\Gigaframe.Com.PowerShell.CGI.Web.ps1);
(. $PSScriptRoot\Gigaframe.Com.PowerShell.CGI.SQL.ps1);
(. $PSScriptRoot\Gigaframe.Com.PowerShell.CGI.MDB.ps1);

<# Web Service Processing #>
#First get method name being requested
$METHODNAME = $QueryVars["m"];

<# Call the respective method of section of code to process #>
If($METHODNAME -eq "SAVEDEVICE")
{
    Write-Host("Content-Type: text/plain");
    Write-Host("");

    $DEVICEID = $PostVars["DEVICEID"];
    $USERID = $PostVars["USERID"];
    $ARCHTECTURE = $PostVars["ARCHTECTURE"];
    $OS = $PostVars["OS"];
    $TAG = $PostVars["TAG"];
    $SERIAL = $PostVars["SERIAL"];
    $INFO = $PostVars["INFO"];
    $DRIVES = $PostVars["DRIVES"];
    $MAPPEDDRIVES = $PostVars["MAPPEDDRIVES"];

    [string] $ConnStr = "Server=(local);Database=Org;User ID=dev;Password=develop123!";
    
    [string] $SQLTxt = "";
    $SQLTxt += "IF EXISTS (SELECT DEVICEID FROM DEVICES WHERE DEVICEID = @DEVICEID) `n";
    $SQLTxt += "UPDATE DEVICES SET [USERID]=@USERID,[ARCHTECTURE]=@ARCHTECTURE,[OS]=@OS,[TAG]=@TAG,[SERIAL]=@SERIAL,[INFO]=@INFO,[DRIVES]=@DRIVES,[MAPPEDDRIVES]=@MAPPEDDRIVES,[LASTUPDATE]=@LASTUPDATE `n";
    $SQLTxt += "WHERE [DEVICEID]=@DEVICEID `n";
    $SQLTxt += "ELSE `n";
    $SQLTxt += "INSERT INTO DEVICES ([DEVICEID],[USERID],[ARCHTECTURE],[OS],[TAG],[SERIAL],[INFO],[DRIVES],[MAPPEDDRIVES],[LASTUPDATE]) `n";
    $SQLTxt += "VALUES (@DEVICEID,@USERID,@ARCHTECTURE,@OS,@TAG,@SERIAL,@INFO,@DRIVES,@MAPPEDDRIVES,@LASTUPDATE) `n";
    
    [List[KeyValuePair[[string],[object]]]] $ParamList = [List[KeyValuePair[[string],[object]]]]::new();
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@DEVICEID",$DEVICEID));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@USERID",$USERID));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@ARCHTECTURE",$ARCHTECTURE ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@OS",$OS ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@TAG",$TAG ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@SERIAL",$SERIAL ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@INFO",$INFO ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@DRIVES",$DRIVES ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@MAPPEDDRIVES",$MAPPEDDRIVES ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@LASTUPDATE",[DateTime]::Now));
    $RetVal = MSSQLExecute -ConnString $ConnStr -SQLStatement $SQLTxt -Params $ParamList;

    $Success = $RetVal.Get($RetVal.Count-1);
    Write-Host("RET:$Success");
}
ElseIf($METHODNAME -eq "SAVEDEVICEPRODUCT")
{
    $THREADNAME = $QueryVars["tn"];

    Write-Host("Content-Type: text/plain");
    Write-Host("");

    $DEVICEID = $PostVars["DEVICEID"];
    $DEVICEPRODUCTID = $PostVars["DEVICEPRODUCTID"];
    $PRODUCTVERSION = $PostVars["PRODUCTVERSION"];

    [string] $ConnStr = "Server=(local);Database=Org;User ID=dev;Password=develop123!";
    [string] $SQLTxt = "INSERT INTO DEVICEPRODUCTS (DEVICEPRODUCTID,DEVICEID,PRODUCTNAME,PRODUCTVERSION,PRODUCTDATA,LASTUPDATE) VALUES (@DEVICEPRODUCTID,@DEVICEID,@PRODUCTNAME,@PRODUCTVERSION,@PRODUCTDATA,@LASTUPDATE)";
    [List[KeyValuePair[[string],[object]]]] $ParamList = [List[KeyValuePair[[string],[object]]]]::new();
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@DEVICEPRODUCTID",$DEVICEPRODUCTID));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@DEVICEID",$DEVICEID));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@PRODUCTNAME",$DEVICEPRODUCTID));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@PRODUCTVERSION",$PRODUCTVERSION ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@PRODUCTDATA",$THREADNAME ));
    $ParamList.Add([KeyValuePair[[string],[object]]]::new("@LASTUPDATE",[DateTime]::Now));
    $RetVal = MSSQLExecute -ConnString $ConnStr -SQLStatement $SQLTxt -Params $ParamList;

    $Success = $RetVal.Get($RetVal.Count-1);
    Write-Host("RET:$Success");
}
ElseIf ($METHODNAME -eq "ANOTHERMETHOD")
{
    Write-Host("0");
}
<#
Testing output in database
Sorted ProductData where load tester saves ThreadName

 SELECT [DEVICEPRODUCTID]
      ,[DEVICEID]
      ,[PRODUCTNAME]
      ,[PRODUCTVERSION]
      ,[PRODUCTDATA]
      ,[LASTUPDATE]
  FROM [ORG].[dbo].[DEVICEPRODUCTS]
  ORDER BY PRODUCTDATA, DEVICEID, LASTUPDATE DESC
#>